# couchdb-ruby-server
CouchDB query server to run ruby design docs.

[![Build Status](https://travis-ci.org/sinm/couchdb-ruby-server.svg?branch=master)](https://travis-ci.org/sinm/couchdb-ruby-server) [![Gem Version](https://badge.fury.io/rb/couchdb-ruby-server.svg)](http://badge.fury.io/rb/couchdb-ruby-server) [![Dependency Status](https://gemnasium.com/sinm/couchdb-ruby-server.svg)](https://gemnasium.com/sinm/couchdb-ruby-server) [![GitHub license](https://img.shields.io/badge/license-MIT-blue.svg)](https://raw.githubusercontent.com/sinm/couchdb-ruby-server/master/LICENSE.txt) [![Code Climate](https://codeclimate.com/github/sinm/couchdb-ruby-server/badges/gpa.svg)](https://codeclimate.com/github/sinm/couchdb-ruby-server) [![Test Coverage](https://codeclimate.com/github/sinm/couchdb-ruby-server/badges/coverage.svg)](https://codeclimate.com/github/sinm/couchdb-ruby-server) [![Inline docs](http://inch-ci.org/github/sinm/couchdb-ruby-server.svg?branch=master)](http://inch-ci.org/github/sinm/couchdb-ruby-server) [![security](https://hakiri.io/github/sinm/couchdb-ruby-server/master.svg)](https://hakiri.io/github/sinm/couchdb-ruby-server/master)

## Installation
`gem install couchdb-ruby-server` as usual.

Edit your couchdb's local.ini and set this in the `[query_servers]` group:

    ruby = couchdb-ruby-server

Restart CouchDB then.

## Usage
Design functions (map, reduce, update, etc.) are well defined as `lambda` or `proc` blocks:

    lambda { |doc| emit [1,2,3], doc }

It looks like any object responding to `#call` will survive.

[Couchapp](couchapp.org) works well with `rb` files, so use it to manage  design files. Just do `echo ruby > language` inside your app's root directory and you're in.

You may load your own code into the query server context by providing path to a library as an `--require LIB` option. This way you could deserialize documents right into the instances of the library classes instead of plain hashes.

Actually any tagname for the query server may be set in `local.ini` instead of `ruby` so it's possible to run several query servers e.g. per application. Just remember to copy that tagname into couchapp's `language` file.

Run `couchdb-ruby-server --help` for the options.

## Tests
`bundle exec rake test`. Gem is trying to follow original [tests](https://github.com/apache/couchdb/blob/master/test/view_server/query_server_spec.rb).

## Documentation
This README is all i could say in a rush. No other documentation provided at this moment, see the sources.

## If you've found a bug or drawback
Don't hesistate to leave a report.

## License
MIT for now.
